;
; dKpXsR	Ver1.4 (spcon14C.asm)
; iėpDC[^[Xs[hRg[j	2002.3 (c) RUU
;
; for PIC12C508/509@4MHz intrc
;

			.include	12c5xx.h
			.12c509
			.mclre		disable
			.osc		intrc		; INT4MHz
			.wdt		off
			.pwrt		on
			.protect	off

TRIG		equ		gpio.0		; gKXCb`
F_SLCT		equ		gpio.1		; PWMgI
DRV_OUT		equ		gpio.2		; [^[hCuPWMo
S_OUT		equ		gpio.4		; A/DϊpCharge/Dischargeo
S_IN		equ		gpio.5		; A/Dϊpd

			org		7


cnt_on		ds		1			; pXONJE^
cnt_off		ds		1			; pXOFFJE^
cnt			ds		1			; ėpJE^
pwm_f		ds		1			; PWMg@0:1.4kHz, 1:2.8kHz


			org		0

start
			mov		option,#00001000b			; GPWU enable, GPPU enable, PS none
			mov		!gpio,#11100011b			; GP0,GP1,GP5͓
			clr		gpio						; o͂'L'ɐݒ

mainloop
			mov		gpio,#00000000b				; [^[OFF
			nop
			nop
			nop
			mov		w,gpio
			nop
			jnb		TRIG,motor_on
			sleep								; gKONɂȂ܂ŃX[v
			nop
motor_on
			mov		gpio,#00010100b				; FETITvORfT̃`[W
			mov		cnt,#255					; 2.5(ms)EFCg
wait_chg
			nop
			nop
			nop
			nop
			nop
			nop
			nop
			djnz	cnt,wait_chg

			mov		pwm_f,#1
			snb		F_SLCT						; gݒ𒲂ׂ
			clr		pwm_f

			clr		cnt_off
			mov		gpio,#00000100b

ad_cnt
			inc		cnt_off						; dׂ'L'xɂȂ܂ŃJEg
			jz		pwr_low
			jb		S_IN,ad_cnt

			cjbe	cnt_off,#5,pwr_high			; JEgl0`250ɕ␳
			sub		cnt_off,#5
			goto	set_duty

pwr_low
			mov		cnt_off,#250				; ŏp[

set_duty
			mov		cnt_on,#251
			cje		pwm_f,#0,set_duty0			; 1.3kHz̏ꍇFJE^1`250͈̔
			clc
			rr		cnt_off						; 2.6kHz̏ꍇFJE^1`125͈̔
			cje		cnt_off,#0,pwr_high
			mov		cnt_on,#126					; ŏp[

set_duty0
			sub		cnt_on,cnt_off
pwm_loop										; pX(1cycle = 380us or 755us)
			mov		cnt,cnt_off
			mov		gpio,#00000000b
loop_off										; 'L'=1`99%
			djnz	cnt,loop_off
			mov		cnt,cnt_on
			mov		gpio,#00000100b
loop_on											; 'H'=99`1%
			djnz	cnt,loop_on

			jnb		TRIG,pwm_loop				; gKON̊LOOP
			goto	mainloop

pwr_high
			mov		gpio,#00000100b				; őp[ Duty=100%
high_loop
			jnb		TRIG,high_loop
			goto	mainloop



;;;;;;;;;;;;;;;;;;; ܂ ;;;;;;;;;;;;;;;;;;;;;;

